<template>
  <form class="formContainer">
    <div>
      <div>
        <label for="Amount">Number of questions </label>
      </div>
      <input
        class="formOptions"
        v-model="questionAmount"
        type="number"
        min="1"
        max="50"
        required
      />
    </div>
    <div>
      <label for="category">Category</label>
    </div>
    <div>
      <select class="formOptions" v-model="selectedCategory">
        <option
          v-for="category in categories"
          :value="category.value"
          :key="category.id"
          v-html="category.category"
        ></option>
      </select>
    </div>
    <div>
      <div>
        <label for="difficulty">Difficulty</label>
      </div>
      <select class="formOptions" v-model="selectedDifficuty">
        <option
          v-for="difficulty in difficulties"
          :value="difficulty.value"
          :key="difficulty.id"
          >{{ difficulty.difficulty }}</option
        >
      </select>
    </div>
    <button class="submitBtn" :disabled="isDisabled" @click="submitForm">
      Start Game
    </button>
  </form>
</template>

<script>
import { mapActions } from "vuex";
import categoriesData from "../../assets/categories";
import difficultiesData from "../../assets/difficulty";

export default {
  name: "Form",
  data: function() {
    return {
      isDisabled: false,
      categories: categoriesData,
      difficulties: difficultiesData,
      questionAmount: 10,
      selectedCategory: "any",
      selectedDifficuty: "any",
    };
  },

  methods: {
    ...mapActions(["createQuestions"]),
    redirectToGame() {
      this.$router.push({ path: "/game" });
    },
    async submitForm() {
      if (this.checkFormNumber(this.questionAmount) === false) {
        return;
      }
      this.isDisabled = true;
      let formData = {
        amount: this.questionAmount,
        category: this.selectedCategory,
        difficulty: this.selectedDifficuty,
      };
      await this.createQuestions(formData);
      this.redirectToGame();
    },
    checkFormNumber(formInputNumber) {
      if (formInputNumber == 0 || formInputNumber > 50) {
        return false;
      }
    },
  },
};
</script>

<style>
.formOptions {
  height: 2em;
  width: 20em;
  background-color: rgb(243, 243, 243);
  border-radius: 4px;
  position: relative;
}

.submitBtn {
  margin-top: 2em;
  height: 3em;
  width: 20em;
}
</style>
